package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvRegularCallEgg;
import com.huimv.guowei.admin.service.IEnvRegularCallEggService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 固定电子秤 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-regular-call-egg")
@CrossOrigin
public class EnvRegularCallEggController {

    @Autowired
    private IEnvRegularCallEggService eggService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return new Result(ResultCode.SUCCESS, eggService.listById(httpServletRequest, paramsMap));
    }

    @RequestMapping("/addEgg")
    public Result addEgg(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return eggService.addEgg(httpServletRequest, paramsMap);
    }
    @RequestMapping("/editEgg")
    public Result editEgg(HttpServletRequest httpServletRequest, @RequestBody EnvRegularCallEgg egg) throws ParseException {
        return eggService.updateEgg(httpServletRequest, egg);
    }
    @RequestMapping("/deleteEgg")
    public Result deleteEgg(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return eggService.deleteEgg(httpServletRequest, paramsMap);
    }
}
